package com.s5gi.giGuns.guns.ind;

import com.s5gi.giGuns.guns.BulletType;
import com.s5gi.giGuns.guns.IGun;
import org.bukkit.*;
import org.bukkit.block.Block;
import org.bukkit.entity.LivingEntity;
import org.bukkit.inventory.CraftingRecipe;
import org.bukkit.inventory.ShapedRecipe;

import java.util.List;

public class m1Bazooka implements IGun {
    @Override
    public String name() {
        return "&4M1 Bazooka";
    }

    @Override
    public List<String> description() {
        return List.of("&9U.S.A.", "&7A man-portable recoilless anti-tank rocket launcher");
    }

    @Override
    public BulletType bulletType() {
        return BulletType.ANTI_TANK;
    }

    @Override
    public List<Sound> sound() {
        return List.of(Sound.ENTITY_GENERIC_EXPLODE, Sound.ENTITY_FIREWORK_ROCKET_BLAST);
    }

    @Override
    public float soundPitch() {
        return 0.55f;
    }

    @Override
    public void onHitEntity(Location location, LivingEntity entity) {
        explode(location);
    }

    @Override
    public void onHitBlock(Location location, Block block) {
        explode(location);
    }

    private static void explode(Location location) {
        location.getWorld().createExplosion(location, 4.5f, false, false);
        location.getWorld().spawnParticle(Particle.EXPLOSION, location, 10, 0.1f, 0.1f, 0.1f);
    }

    @Override
    public double bulletSpeed() {
        return 2.8;
    }

    @Override
    public double damage() {
        return 18;
    }

    @Override
    public int cooldown() {
        return 200;
    }

    @Override
    public int textureId() {
        return 5;
    }

    @Override
    public CraftingRecipe recipe() {
        ShapedRecipe recipe = new ShapedRecipe(NamespacedKey.fromString("giguns:m1_bazooka"), compileGun());
        recipe.shape("III","rgT","IIs");
        recipe.setIngredient('T', Material.TNT);
        recipe.setIngredient('I', Material.IRON_BLOCK);
        recipe.setIngredient('r', Material.BLAZE_ROD);
        recipe.setIngredient('s', Material.STICK);
        recipe.setIngredient('g', Material.GUNPOWDER);
        return recipe;
    }
}
